





/*
 *house of ghost public.ino
 * Example sketch for escape room
 *
 * Copyright (c)AfroTek inc.
 * Website    : samuelwalkerat@gmail.com
 * Author     : samuel walker 
 * Create Time: oct 2016
 * Change Log :
 *
 * The MIT License (MIT)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */



#include<CountUpDownTimer.h>
#include <U8g2lib.h>//library to add i2c oled screen not used wait for updates
#include <U8x8lib.h>//
//#include <SPI.h>
#include <DFPlayer_Mini_Mp3.h>// music player library
#include <SD.h>


#ifdef U8X8_HAVE_HW_SPI

#endif

int Inputs = 13;// change this number to the set the # of inputs  you plan to have 
int startpin = 54;// i use all analog inputs as inputs so on the mega it starts at 54 feel free to just use any digital pin to start
int buttons [13];// ALSO CHANGE THIS 
boolean buttonsBool [13];// AND THIS 

U8X8_SSD1306_128X64_NONAME_SW_I2C u8x8(/* clock=*/ SCL, /* data=*/ SDA, /* reset=*/ U8X8_PIN_NONE);   // OLEDs without Reset of the Display
bool startstate = true;
bool  pausestate = true;


// in my set up i have a row of sensor ALL going to analog inputs, and a few rows of outputs 


//Inputs
const int input01 = A1;
const int input02 = A2 ;
const int input03 = A10;
const int input04 = A4;
const int input05 = A6;
const int input06 = A3;
const int input07 = A11;
const int input08 = A7;
const int input09 =  A8;
const int input10 = A10;
const int input11 = A11;
const int input12 = A12;
const int input13 = A13;
//OutPuts

//green these colors are specific to my set up
const int output01 = 2;//correct
const int output02  = 3;//correct
const int output03 = 4;//correct
const int output04 = 5;
const int output05 = 6;
const int output06 = 7;
const int output07 = 8;
const int output08 = 9;
//blue
const int output09 = 9;
const int output10 = 36 ;
const int output11 = 34 ;
const int output12 = 32 ;
const int output13 = 28 ;
const int output14 = 30 ;
const int output15 = 26;
const int output16 = 24;
//red
const int output17 = 40;//correct
const int output18 = 42;//
const int output19 = 44;
const int output20 = 46 ; ////correct
//remote buttons
// some of these button i didnt finish the code for just yet exspect more versions later 


const int startButton = 43; // starts Quest changed to hardware restart, im no longer using software reset 
const int pauseButton = 45; // starts quest after boot/pause/resume quest
//const int doorButton = 43;
const int doorbutton = 47;// opens each door in order untill all are open push one more time and all door back to closed
const int progressButton = 49; // activate acutuators in order (piano, smoke machine, chandelier swing, ballunderbed,)
const int testButton = 51; // starts test loop then runs threw each sensor in order.
//const int magnetsButton = 45; // toggles all magnest on or off/ for reset purposes
//const int lightsButton = 43; // toggles lights on or off
int starttime = 3600000; //60 mins
int curretTime = 0;
CountUpDownTimer TU(UP, HIGH);// TU is counting up from zero
CountUpDownTimer T(DOWN);// counting down 
boolean isPlaying = digitalRead(31);
int progress = 1;// used to keep track of progress
int currentProgress = 0;// this is later used to keep track of progress in relation to button press
int test = 1;// keep track of tested sensor 



void setup() {
  // put your setup co1de here, to run once:
  Serial.begin(9600);//for standard comport serial read
  Serial1.begin(9600);// bluetooth communication, i basically just wrote every serial
  Serial2.begin(9600);//mp3 player im using the dfplayer mini which is good because it dosent bogg down arduino with spi commucation .

  // bool dollmusic = true;
  mp3_set_serial (Serial2);  //set softwareSerial for DFPlayer-mini mp3 module
  delay(1);  //wait 1ms for mp3 module to set volume
  mp3_set_volume (25);//0 to 30 volume
  // mp3_play (2);//
  //mp3_play (1);
  // byte i;
  pinMode(output01, OUTPUT);
  pinMode(output16, OUTPUT);
  pinMode (output03, OUTPUT);
  pinMode(output02, OUTPUT);
  pinMode(output04, OUTPUT);
  pinMode(output05, OUTPUT);
  pinMode(output06, OUTPUT);
  pinMode( output07, OUTPUT);
  pinMode( output08, OUTPUT);
  pinMode(output10, OUTPUT);
  pinMode(output11, OUTPUT);
  pinMode( output12, OUTPUT);
  pinMode(output13, OUTPUT);
  pinMode(output14, OUTPUT);
  pinMode(output15, OUTPUT);
  pinMode(output17, OUTPUT);
  pinMode(output18, OUTPUT);
  pinMode(output19, OUTPUT);
  pinMode(output20, OUTPUT);
  pinMode(input01, INPUT);
  pinMode(input02, INPUT);
  pinMode(input03, INPUT);
  pinMode(input04, INPUT);
  pinMode(input05, INPUT);
  pinMode(input06, INPUT);
  pinMode(input07, INPUT);
  pinMode(input08, INPUT);
  pinMode(input09, INPUT_PULLUP);
  pinMode(input10, INPUT);
  pinMode(input11, INPUT);
  pinMode(input12, INPUT);
  pinMode(input13, INPUT);
  //digitalWrite(output20,LOW);
 
 // remote relay buttons all grounded so a input pull gives you a high reading when pressed  
  pinMode( doorbutton, INPUT_PULLUP);
  pinMode(startButton , INPUT_PULLUP);
  pinMode(pauseButton , INPUT_PULLUP);
    pinMode(progressButton , INPUT_PULLUP);

  alloff();//turns everything off ,for magnets in my set up this means on

  //digitalWrite(output08,LOW);
  delay(1500);
  //TimedON();

  digitalWrite(output12, LOW);
  digitalWrite(output17, LOW);
  digitalWrite(output02, LOW );
  digitalWrite( output08, LOW);
  delay(1500);
  digitalWrite( output08, HIGH);
  digitalWrite(output05, LOW); // all magnets must be low to be on
  digitalWrite(output06, LOW); // all magnets must be low to be on
  digitalWrite(output11, LOW); // all magnets must be low to be on
  digitalWrite(output01, LOW); // all magnets must be low to be on
  digitalWrite(output07, LOW);
  digitalWrite(output10, LOW);
  digitalWrite(output04, LOW);

  
bootUP();// runs boot up and waits for pause button to start

  // Make input & enable pull-up resistors on switch pins
  for (int i = 0; i < Inputs; i++)buttons[i] = i + startpin;
  for (int i = 0; i < Inputs; i++)buttonsBool[i] = false;
  for (int i = 0; i < Inputs; i++)pinMode(buttons[i], INPUT_PULLUP);






}

void loop() {
  // put your main code here, to run repeatedly:
  //if(digitalRead(startButton) == LOW){
  //  if (! musicPlayer.startPlayingFile("track001.mp3")) {
  // Serial.println("Could not open file track001.mp3");
  // while (1);
  //}
  //if (digitalRead(pauseButton) == HIGH){
  T.Timer();
  TU.Timer();//starts count up timer

  // while (musicPlayer.playingMusic) {
  // file is now playing in the 'background' so now's a good time
  // to do something else like handling LEDs or buttons :)
  //Serial.print(".");
  // delay(1000);
  boolean isPlaying = digitalRead(31);//pin on dfplayer lets you know if music is play at the moment 
  if (T.TimeHasChanged() ) // this prevents the time from being constantly shown.  it also allows anything inside this IF statment to run every second time has changed  
  {
    Serial.print("  count Down ");
    Serial.print(T.ShowHours());
    Serial.print(":");
    Serial.print(T.ShowMinutes());
    Serial.print(":");
    Serial.print(T.ShowSeconds());
    Serial.print(":");
    Serial.print(T.ShowMilliSeconds());
    Serial.print(":");
    Serial.print(T.ShowMicroSeconds());
    Serial.print("  count up ");
    Serial.print(TU.ShowHours());
    Serial.print(":");
    Serial.print(TU.ShowMinutes());
    Serial.print(":");
    Serial.print(TU.ShowSeconds());
    Serial.print(":");
    Serial.print(TU.ShowMilliSeconds());
    Serial.print(":");
    Serial.println(TU.ShowMicroSeconds());
    Serial1.print("  count Down ");
    Serial1.print(T.ShowHours());
    Serial1.print(":");
    Serial1.print(T.ShowMinutes());
    Serial1.print(":");
    Serial1.print(T.ShowSeconds());
    Serial1.print(":");
    Serial1.print(T.ShowMilliSeconds());
    Serial1.print(":");
    Serial1.print(T.ShowMicroSeconds());
    Serial1.print("  count up ");
    Serial1.print(TU.ShowHours());
    Serial1.print(":");
    Serial1.print(TU.ShowMinutes());
    Serial1.print(":");
    Serial1.print(TU.ShowSeconds());
    Serial1.print(":");
    Serial1.println(TU.ShowMilliSeconds());
    Serial.print("is playing");
    Serial.println(isPlaying);
  
    timetracker();// time tracker is where you can add timed events for example you want a voice to activate or lights to come on quest to end.
 progressKeeper();// progresskeeper is actually a function to keep the progress button on the correct case.

 
    if ( digitalRead(startButton) == !startstate ) {// in my set up i actually have the start button relay connected directly to RESET Pin so no code needed but you may want to do a software start also so put code here.  
      Serial.println("start button has been pressed");
      startstate = !startstate;
      // resetMode();
    }

    if (digitalRead(pauseButton) == HIGH) {
      Serial.println("pause button has been pressed");
      Serial1.println("pause button has been pressed");
      T.PauseTimer();
      // pausestate = !pausestate;

      digitalWrite(output15, HIGH);
      delay(500);
      digitalWrite(output15, LOW);
      delay(700);
      digitalWrite(output15, HIGH);
      delay(500);
      digitalWrite(output15, LOW);
      // delay(50000);
      //              break;
      //   if (digitalRead(pauseButton) ==  LOW){
      //   Serial.print(".");
      // delay(500);
      // }

      if (digitalRead(pauseButton) == HIGH) {
        digitalWrite(output15, HIGH);
        delay(500);
        digitalWrite(output15, LOW);
        delay(700);
        digitalWrite(output15, HIGH);
        delay(500);
        digitalWrite(output15, LOW);
        T.ResumeTimer();
      }
    }

    for (int i = 0; i < Inputs; i++) {

      if (!buttonsBool[i]) {
        if (digitalRead(buttons[i]) == LOW) {
          Serial.print("input number" + String(i) + ":");
          Serial.print(1);
          Serial.print("button pin");
          Serial.println(buttons[i]);
          Serial1.print("input number" + String(i) + ":");
          Serial1.print(1);
          Serial1.print("button pin");
          Serial1.println(buttons[i]);
          int current = map (Inputs, 0, 12, 0, 12);
          buttonsBool[i] = true;
          switch (i) {
            case 0:  

             
            if(progress == 6 )
             {
            //play door audio
              Serial.println("put info for operator on whats supposed to happen ");
              Serial1.println("put info for operator on whats supposed to happen ");
              delay(1000);
              Serial.println("put info for operator on whats supposed to happen ");
              Serial1.println("put info for operator on whats supposed to happen ");
              mp3_play (5);
              digitalWrite(output11, HIGH);
              digitalWrite(output16, LOW);
              delay(2000);
              digitalWrite(output16, HIGH);
              digitalWrite(output15, HIGH);
              delay(1000);
              digitalWrite(output15, LOW);
              delay(700);
              digitalWrite(output15, HIGH);
              delay(1500);
              digitalWrite(output15, LOW);
              delay(1000);
              digitalWrite(output15, LOW);
              delay(700);
              digitalWrite(output15, HIGH);
              delay(1500);
              digitalWrite(output15, LOW);
                     Serial1.print("progress");
            Serial1.println(progress);
              progress++;
            }
              break;
            case 1:    // replace with new sensor
                       Serial.println("put info for operator on whats supposed to happen ");
              Serial1.println("put info for operator on whats supposed to happen ");
              delay(1500);
              digitalWrite(output13, LOW);
              Serial.println("play video 1");
              break;
            case 2:    // replace
                   Serial.println("put info for operator on whats supposed to happen ");
              Serial1.println("put info for operator on whats supposed to happen ");
              digitalWrite( output12, LOW);

              Serial.println("alter box magnet  is off");
              break;
      case 3:
      
            if(progress == 2 ){// this if ensures that the event happens only once so if the button was pressed or activated with sensors it does not repeat
          pinMode(input06,INPUT); 

           delay(3000);
           if (digitalRead(input06) == LOW){
            delay(200);
           } 
        else            {
            
    Serial1.print("record");
 Serial1.println(digitalRead(input06));
            // play some old song maybe jeepers creepers
              Serial.print("the player has found the correct record ");
              Serial.println("secret piano is open ");
              digitalWrite(output02, HIGH);
               delay(2000);
               digitalWrite(output03, LOW);
              delay(3000);
              digitalWrite(output03, HIGH);
              digitalWrite(output02, HIGH);
              mp3_play (2);

              Serial1.print("the player has found the correct record ");
              Serial1.println("secret piano is open ");
              digitalWrite(output03, LOW);
              delay(3000);
              digitalWrite(output03, HIGH);
              digitalWrite(output02, HIGH);
              digitalWrite(output19, LOW);
              delay (5000);
              digitalWrite(output19, HIGH);
              digitalWrite(output15, HIGH);
              delay(500);
              digitalWrite(output15, LOW);
              delay(700);
              mp3_play (1);
              digitalWrite(output15, HIGH);
              delay(500);
              digitalWrite(output15, LOW);
              delay(50000);
              digitalWrite( output07, HIGH);
                     Serial1.print("progress");
            Serial1.println(progress);
            progress ++;
            }
            }
           // pinMode(input06,INPUT_PULLUP); 
              break;
            case 4:    // your hand is nowhere near the sensor
              Serial.print("got key from box");
              digitalWrite(output17, LOW);

              Serial.println("");
            case 5:    // your hand is nowhere near the sensor
              Serial.print("got key from box");
              digitalWrite(output17, LOW);

              Serial.println("");



              Serial.println("play video number 2 ");
              break;
              Serial.println("open sercret piano door.");
            case 6:  
            
            if(progress == 3 ){// your hand is on the sensor
              Serial.print("pencil Holder");
              Serial1.print("pencil Holder");

              digitalWrite(output05, HIGH);
              digitalWrite(output19, LOW);
              delay (7000);
              digitalWrite(output19, HIGH);

              Serial.println("opens small drawer.");
              Serial1.println("opens small drawer.");
                     Serial1.print("progress");
            Serial1.println(progress);
              progress++;
            }
              break;
            case 7:    // your hand is nowhere near the sensor
              Serial.print(" the operator has correctly placed aquarium medalion.");
              Serial1.print(" the operator has correctly placed aquarium medalion.");
              //digitalWrite(output19,LOW);
              // mp3_play (7);// rummble
              digitalWrite(output20, LOW);
              delay(1500);
              digitalWrite(output20, HIGH);
              delay(1500);
              digitalWrite(output20, LOW);
              delay(1500);
              digitalWrite(output20, HIGH);
              break;
            case 8:   
            
            
            if(progress == 5 ){
            // your hand is on the sensor
              Serial.print("correct doll combination");
              Serial1.print("correct doll combination");


            //  if (dollmusic == true) {
                mp3_play (9);// play akira !!!!!!!!!!!
             //   bool dollmusic = true;
              //}
              digitalWrite(output10, HIGH);
              Serial.println("opens girls secret drawer ");
              Serial1.println("opens girls secret drawer ");
              delay(5000);
              Serial.println("ball is activated ");
              Serial1.println("ball is activated ");

              digitalWrite( output08, LOW);
              delay(1500);
              digitalWrite( output08, HIGH);
                     Serial1.print("progress");
            Serial1.println(progress);
              progress++;
            }
              break;
            case 9:    // your hand is close to the sensor
              Serial.print("players are on the bed ");

              digitalWrite(output01, LOW);
              Serial.println("the kids room door should be open");
              break;

            case 10:    
            
            if(progress == 4 ){
            // your hand is a few inches from the sensor
              Serial.print("piano wrong key");
              Serial1.print("piano wrong key");
              digitalWrite (output03, LOW);
              delay(1300);
              mp3_play (5);
              digitalWrite (output03, HIGH);
              // digitalWrite(output02, HIGH);
              digitalWrite(output16, LOW); // play thunder sound effect
              digitalWrite(output15, LOW);
              // mp3_play (3);// dooor unlocking sound
              digitalWrite(output20, LOW);
              delay(1500);
              digitalWrite(output16, HIGH);
              digitalWrite(output20, HIGH);
              Serial.println(" kids room open");
              Serial1.println(" kids room open");
              mp3_play (3);// dooor unlocking sound
              digitalWrite(output01, HIGH);
                     Serial1.print("progress");
            Serial1.println(progress);
              progress++;
            }
            break;
            case 11:  
            
            if(progress == 1 ){
            // your hand is a few inches from the sensor
              Serial.print("when clocks are wound.");
              Serial.println("table larger drawer is open");
              Serial.print("first event.");
              Serial1.println("first event.");
              Serial1.print("when clocks are wound.");
              Serial1.println("table larger drawer is open");
              digitalWrite(output06, HIGH);
              digitalWrite(output15, HIGH);
                     Serial1.print("progress");
            Serial1.println(progress);
              progress ++;
            }
              
              break;



          }
        }
      }
      else {
        if (digitalRead(buttons[i]) == HIGH) {

          Serial.print("input number" + String(i) + ":");
          Serial.println(0);
          buttonsBool[i] = false;
          Serial1.print("input number" + String(i) + ":");
          Serial1.println(0);

          switch (i) {
      
            case 7:    // your hand is nowhere near the sensor
              Serial.print("player has picked up aquarium medalion.");
              Serial1.print("player has picked up aquarium medalion.");
              digitalWrite( output12, HIGH);
              digitalWrite(output19, LOW);
              digitalWrite(output20, LOW);
              delay(5000);
              digitalWrite(output19, HIGH);
             // progress++;
              break;

            case 12:    
            if(progress == 7 ){
              // your hand is on the sensor
            
              Serial.print("freddy plant waterd .... ");
              Serial1.print("freddy plant waterd .... ");
              T.PauseTimer();
              digitalWrite(output14, LOW);
              //digitalWrite(output14,HIGH);
              digitalWrite(output04, HIGH);
              Serial.print("the quest is over  ");
              Serial.print("your final time is  ");
              Serial.println(TU.ShowMinutes() );
              delay(1000);
              Serial.print("your final time is  ");
              Serial.println(TU.ShowMinutes() );
              Serial.print("your final time is  ");
              delay(5000);
              Serial.print("your final time is  ");
              Serial.println(TU.ShowMinutes() );
              delay(10000);
              Serial.print("your final time is  ");
              Serial.println(TU.ShowMinutes() );
              delay(3000);
              Serial.print("your final time is  ");
              Serial.println(TU.ShowMinutes() );
                     Serial1.print("progress");
            Serial1.println(progress);
            if (digitalRead(pauseButton) == HIGH ||digitalRead(progressButton) == HIGH){
                      Serial.print("your final time is  ");
              Serial.println(TU.ShowMinutes() );
                     Serial1.print("progress");
            Serial1.println(progress);
                    Serial1.print("your final time is  ");
              Serial1.println(TU.ShowMinutes() );
                     Serial.print("progress");
            Serial.println(progress);
            }
            }
              break;
            case 5:    //
              Serial.print("piano complete");
              digitalWrite(output02, LOW);
              digitalWrite(output16, LOW); // play thunder sound effect
              digitalWrite(output15, LOW);
              digitalWrite(output20, LOW);
              delay(1500);
              digitalWrite(output16, HIGH);
              digitalWrite(output20, HIGH);
        
              progress ++;
                Serial1.print("progress");
            Serial1.println(progress);
              break;
          }


        }
      }


      /* if (digitalRead(startButton) == LOW) {
         resetMode();
        }
        if (digitalRead(pauseButton) == LOW) {
         T.PauseTimer();
        }
        if (digitalRead(pauseButton) == LOW) {
         T.ResumeTimer();
         delay(500);
        }

        break;
        }*/
    }


  } if (digitalRead(pauseButton) == HIGH) {
    Serial.println("pause button has been pressed");
    Serial1.println("pause button has been pressed");
    mp3_play (6);// play car beep
    T.PauseTimer();
    // pausestate = !pausestate;

    digitalWrite(output15, HIGH);
    delay(500);
    digitalWrite(output15, LOW);
    delay(700);
    digitalWrite(output15, HIGH);
    delay(500);
    digitalWrite(output15, LOW);
    // delay(50000);
    //              break;
    while (digitalRead(pauseButton) ==  LOW) {
      Serial.print(".");
      Serial1.print(".");
      delay(500);
    }

    if (digitalRead(pauseButton) == HIGH) {
      Serial.println("pause button has been pressed! game is unpaused");
      Serial1.println("pause button has been pressed! game is unpaused");
      mp3_play (6);//play car beep sound
      digitalWrite(output15, HIGH);
      delay(500);
      digitalWrite(output15, LOW);
      delay(700);
      digitalWrite(output15, HIGH);
      delay(500);
      //   digitalWrite(output15, LOW);
      T.ResumeTimer();
    }
  }
  // if (digitalRead(pauseButton) == !pausestate) {
  //Serial.print(".");
  //T.ResumeTimer();
  //delay(50);
  //  pausestate =!pausestate;
  //}
}
//}

